/*
 * +Contactes
 * 
 * Treball Final de Carrera
 * Desenvolupament d'aplicacions per dispositius mbils 2014                   
 * 
 * @author Maia Garrgs Sarr
 * @tutor  Jordi Almirall Lpez i Ignasi Lorente Puchades
 * 
 */

(function () {

    /* ---------------------------------- Local Variables ---------------------------------- */
    var adapter = new JSONPAdapter();
    adapter.initialize().done(function () {
        console.log("Data adapter json initialized");
    });

    var adapter_localStore = new LocalStorageAdapter();
    adapter_localStore.initialize().done(function () {
        console.log("Data adapter localStore initialized");
    });

    /* --------------------------------- Event Registration -------------------------------- */
    // Element que volem que mostri cada vegada
    // Store object
    var storeObject = {
    	per_pag : 10,            //resultats que volem per pgina (o per scroll)
    	pag : 1,                 //pagina inicial on ens trobem
    	tot_carregat : false,    //Com fem scroll i anem reccarregant la llista necessitem saber quan tenim tots els resultats
    	codi_usuari : ''         //Cada vegada que mirem el detall d'un usuari ens quedem amb el seu id.
    }

    //Carreguem les llistes d'organics i recinte al formulari abanat
    pintar_llista_organic();
	pintar_llista_recinte();
    
	//Clickem el bot de buscar
    /*$("#submit_buscar").on("vclick", function(){
    	$('#form1').submit();
    });*/
	
	$('#form1').submit(function(e) {
        $.mobile.loading('show', {text: "Si us plau, espereu", textVisible: true});
    	$('#llista-usuaris').empty();
    	$('#valor-cercat').empty();
    	
    	//inicialitzem variable de tot_carregat i num de pagines.
    	storeObject.tot_carregat = false;
    	storeObject.pag = 1;
    	
    	//busquem els 10 primers resultats de la cerca
        mostrarResultats(storeObject.pag,storeObject.per_pag);
        
        //Anem a la pagina de resultats
        $.mobile.changePage($("#resultats_cerca"));
        $.mobile.loading('hide');
        return false;
      });
    
    //fem scroll sobre la llista de resultats, es va recarregant la llista a mida que avana
    $(document).on("vmousemove","#llista-usuaris", function(event) {
        if ($(window).scrollTop() >= $(document).height() - $(window).height() - 100) {
        	if (!storeObject.tot_carregat){
        		carregarPaginaSeguent();
        	}
        }
      });
    
    //quan seleccionem un empleat de la llista de resultats
    $(".employee-list").on("click", "li", function() { 
    	storeObject.codi_usuari = $(this).attr("data-value");
		pintar_detall_empleat(storeObject.codi_usuari);
    });
    
    //si cliquem bot de veure favorits
     $(document).on("click","#boto_favorit", function() { 
       		mostrarContacteAFavorits();
    		$.mobile.changePage($("#resultats_cerca_favorits"));
    });
     
     //si cliquem un empleat de la llista de favorits
     $(".empleats-favorits").on("click", "li", function() { 
     	storeObject.codi_usuari = $(this).attr("data-value");
 		pintar_detall_empleat(storeObject.codi_usuari);
     });
    
    //Quan cliquen sobre el nom de la persona
    $("#ul_detall_contacte").on("click", "li", function() { 
    	//l'afegim a favorits
    	if($(this).attr("data-icon")=="star"){
    		afegirContacteAFavorits();
    		$.mobile.changePage($("#resultats_cerca_favorits"));
    	}
    	//l'eliminem de favorits
    	if($(this).attr("data-icon")=="delete"){
    		eliminarContacteDeFavorits($(this).attr("data-value"));
    		$.mobile.changePage($("#resultats_cerca_favorits"));
    	}
    	 //Si volem afegir un contacte al nostre mbil,
    	if($(this).attr("data-icon")=="check"){
    		$( "#dadesafegides" ).popup( "open" );
    	}
    });

    //Si volem afegir un contacte al nostre mbil
    $("#afegir_al_mobil").on("vclick", function(e){
    	$( "#dadesafegides" ).popup( "close" );
    	afegirContacteAlMobil();
    });
    
    /* ---------------------------------- Local Functions ---------------------------------- */
	
    /*
     * Funcio Pintar llista organic
     * 
     * Pinta el select que hi ha en el formulari abanat de cerca sobre les unitats organiques
     * Aquest resultat s'obt del webservice d'organics.
     */
    function pintar_llista_organic()
	{
    	if ($("#pagina_cerca").find('#search-organic').length === 0) {
    	 adapter.findOrganic().done(function (downloadedJson) {
    		 var html = "";
    		 html += '<label for="search-organic" class="ui-hidden-accessible">Selecciona organic</label>';
    		 html += '<select data-native-menu=false id="search-organic">';
    		 html += '<option value=""  id="search-organic-option0">Selecciona organic</option>';
			  var l = downloadedJson.elements.length;
		      var e;     
	          for (var i = 0; i < l; i++) {
	          	  var e = groupFromArrayToSingleObject(downloadedJson.elements[i]);
	          	  html += '<option value="' + e["organic"] + '">' + e["organic_desc"] + '</option>';
		      }
	         // $("#home div:jqmData(role=content)").append (response); .trigger( "create" );
	          html += '</select>';
	          
	          $("#search-organic-content").append (html);
	          $("#search-organic").selectmenu ();
    	 });
    	}
	}
    
	
    /*
     * function Pintar llista recinte
     * 
     * Pinta el select que hi ha en el formulari abanat de cerca sobre els recintes
     * Aquest resultat s'obt del webservice de recintes.
     */
    function pintar_llista_recinte()
	{
    	if ($("#pagina_cerca").find('#search-recinte').length === 0) {
    	 adapter.findRecinte().done(function (downloadedJson) {
    		 var html = "";
    		 html += '<label for="search-recinte" class="ui-hidden-accessible">Selecciona recinte</label>';
    		 html += '<select id="search-recinte"  name="search-recinte"  data-native-menu="false">';
    		 html += '<option value="" id="search-recinte-option0" >Selecciona recinte</option>';
			  var l = downloadedJson.elements.length;
		      var e;     
	          for (var i = 0; i < l; i++) {
	          	  var e = groupFromArrayToSingleObject(downloadedJson.elements[i]);
	          	  html += '<option value="' + e["id_centre_treball"] + '">' + e["centre_treball"] + '</option>';
		      }
	          html += '</select>';
	          
	          $("#search-recinte-content").append (html);
	          $("#search-recinte").selectmenu ();
    	 });
    	}
	}

    /*
     * function groupFromArrayToSingleObject
     * 
     * Reestructura les dades recullides del webservice
     * 
     * @param arrayToGroup array retornat pel webservice
     * @return array formatat
     */
    function groupFromArrayToSingleObject(arrayToGroup)
	{
		var auxObject = {};
		for(var i=0; i<arrayToGroup.length; i++)
		{
			for(var key in arrayToGroup[i])
			{
				if(arrayToGroup[i].hasOwnProperty(key))
				{
					auxObject[key] = arrayToGroup[i][key];
				}
			}
		}
		return auxObject;
	}
    
    /*
     * function carregarPaginaSeguent
     * 
     * Funci que carrega els segents 10 elements de la llista
     */
    function carregarPaginaSeguent() {
    	mostrarResultats(++storeObject.pag, storeObject.per_pag); 
    }

    /*
     * Funci que mostra 10 resultats obtinguts junt amb les dades cercades
     * 
     * @param pag int pagina que volem comenar a mostrar
     * @param per_pag  int element que mostrarem
     */
    function mostrarResultats(pag, per_pag) {
    	if ( pag == 1){
	    	if ( $('.search-key').val() != ""){
	    		$('#valor-cercat').append('Paraula clau: <b> ' + $('.search-key').val()  +'</b> <br>');
	    	};
	    	if ($('#search-organic').val() != ""){
	    		$('#valor-cercat').append('Unitat org&aacute;nica: <b> ' + $("#search-organic :selected").text() +'</b> <br>');
	    	};
	    	if ($('#search-recinte').val() != ""){
	    		$('#valor-cercat').append('Centre de treball: <b> ' + $("#search-recinte :selected").text() +'</b> <br>');
	    	};
	    	if ($('#search-ordre').val() != ""){
	    		$('#valor-cercat').append('Ordenat per: <b> ' + $("#search-ordre :selected").text() +'</b> <br>');
	    	};
    	};

        adapter.buscarResultats($('.search-key').val(),$("#search-organic").val(),$("#search-recinte").val(),$("#search-ordre").val(),pag,per_pag).done(function (downloadedJson) {
        	pintar_resultats_cerca(downloadedJson,pag); 
        });
    }
    
    /*
     * function pintar_resultats_cerca
     * 
     * printa resultats de cerca en una llista
     * Aquest resultats els obt de consultar-ho al webservice 
     * 
     * @param downloadedJson array resultat del webservice
     * @param pag int pgina que pintem
     */
    function pintar_resultats_cerca(downloadedJson,pag)
    	{
    	  var l = downloadedJson.elements.length;
          var e;     
          //Mirem si ja ha arribat al final de la llista i si ha arribat diem que ja estat carregat tot.
          if(l==0){
        	  storeObject.tot_carregat = true;
        	  //Si ens trobem a la primera pgina s que no hi ha ms resultats. 
        	  if (pag==1){
        		  $('.employee-list').append('<li>No hi ha resultats per aquesta cerca</li>');
        	  }
          }else{
        	  if (pag==10){
        		  $('#avis').append('<p>La cerca t&eacute; masses resultats, si us plau, afineu la cerca</p>');
        		  storeObject.tot_carregat = true;
        	  }else{
		          for (var i = 0; i < l; i++) {
		          	var e = groupFromArrayToSingleObject(downloadedJson.elements[i]);
		          	
		          	if((e["telefon_contacte"].length)< 9 ){
		          		  telefon = '<a href="#purchase" data-rel="popup" data-position-to="window" data-transition="pop" class="ui-btn ui-btn-icon-notext ui-icon-phone ui-btn-a">Trucar</a>';
		              }else{
		            	  telefon = '<a href="tel:' + e["telefon_contacte"] +'" class="ui-btn ui-btn-icon-notext ui-icon-phone ui-btn-a">Trucar</a>';
		              }
		              $('.employee-list').append('<li class="ui-li-has-alt ui-li-has-thumb" data-value="'+e["contacte_id"]+'"><a href="#detall_contacte"   class="ui-btn"><img src="img/persona.png"><h2>' + 
		            		  e["nom"] + ' ' + e["cognoms"] +
				              '</h2><p>' + e["organic_desc"] + '<br>Tel. '+ e["telefon_contacte"] +
				              '</p></a>' + telefon + '</li>');
		              
			      }
        	 
		          //Mirem si el total de registres s ms petit que el nombre d'elements a carregar, aix voldra dir que hem arrivat al final de la llista a carregar
		          if(l%storeObject.per_pag != 0){
		        	  storeObject.tot_carregat = true;
		          }else{
		        	  storeObject.tot_carregat = false;
		          } 
        	  }
	     }
          
    }
    
    
    /*
     * function pintar_detall_empleat
     * 
     * printa detall d'un empleat en una llista
     * Aquest resultats els obt de consultar-ho al webservice 
     * 
     * @param codi_usuari string codi de l'usuari
     */
    function pintar_detall_empleat(codi_usuari){
    	
    	 adapter.buscarPerId(codi_usuari).done(function (downloadedJson) {
    		 var e = groupFromArrayToSingleObject(downloadedJson.elements[0]);
    		 $("#ul_detall_contacte").empty().listview();
    		 $("#ul_detall_contacte").append ('<li data-name="'+ e["nom"] + '"  data-value="'+ e["cognoms"] + '" id="li_nom"><img src="img/persona.png"><h2>'
    		 				+ e["nom"] + ' ' + e["cognoms"] + '</h2></li>');
    		 if((e["telefon_contacte"].length)< 9 ){
    			 $("#ul_detall_contacte")
    			 	.append ('<li data-icon="phone" data-value="' + e["telefon_contacte"] + '" data-name="' + e["telefon_contacte"] + '" id="li_tel"><a href="#purchase2" data-rel="popup" data-position-to="window" data-transition="pop"><b>Tel&egrave;fon</b><div id="detall_telf">'
    					 + e["telefon_contacte"] +'</div></a></li>');
    		 }else{
    			 $("#ul_detall_contacte").append ('<li data-icon="phone" data-value="' + e["telefon_contacte"] + '" id="li_tel"><a href="tel:'
    					 + e["telefon_contacte"] +'"><b>Tel&egrave;fon</b><div id="detall_telf">'
    					 + e["telefon_contacte"] +'</div></a></li>');
    		 }
    		 $("#ul_detall_contacte").append ('<li data-icon="mail" data-value="' + e["email"] + '" id="li_email"><a href="mailto:' 
    				 + e["email"] + '"><b>Correu</b><div id="detall_correu">' + e["email"] + '</div></a></li>');
    		 $("#ul_detall_contacte").append ('<li data-value="' + e["organic_desc"] + '" id="li_organic"><b>Unitat Org&agrave;nica</b><br>' + e["organic_desc"] +'</li>');
    		 $("#ul_detall_contacte").append ('<li data-value="' + e["centre_treball"] + '" id="li_recinte"><b>Centre de treball</b><br>' + e["centre_treball"] +'</li>');
    		 $("#ul_detall_contacte").append ('<li data-value="' + codi_usuari  + '" data-icon="check" id="afegir_al_mobil"><a href="#"  >Afegeix a contactes del m&ograve;bil</a></li>');

    		 adapter_localStore.findById(codi_usuari).done(function (empleat) {
     			 	if(empleat==null){
    			 		 $("#ul_detall_contacte").append ('<li data-value="' + codi_usuari  + '" data-icon="star" id="id_usuari"><a href="#"  >Afegir contacte a favorits</a></li>');
    			 	}else{
    			 		 $("#ul_detall_contacte").append ('<li data-value="' + codi_usuari  + '" data-icon="delete" id="eliminar_id_usuari"><a href="#"  >Eliminar contacte de favorits</a></li>');
    			 	};
        	});
        		 
    		 //Li diem que carregui els estils
       		 $("#ul_detall_contacte").listview('refresh');
     	 });
    }

    /*
     * function mostrarContacteAFavorits
     * 
     * Mostra aquells contactes guardats com a favorits al storage.
     */
    function mostrarContacteAFavorits() {
        empleats = JSON.parse(window.localStorage.getItem("empleats"));
        pintarLlistaFavorits(empleats);
        
    }
    
    /*
     * function afegirContacteAFavorits
     * 
     * Afegeix un contacte com a favorits al storage.
     */
    function afegirContacteAFavorits() {

    	array_buit=[];
  	
    	var nova_entrada =  {
    			contacte_id:   $("#id_usuari").attr("data-value"),
				nom: $("#li_nom").attr("data-name"), 
				cognoms:$("#li_nom").attr("data-value"), 
				telefon_contacte:  $("#li_tel").attr("data-value"),
				email: $("#li_email").attr("data-value"), 
				organic_desc: $("#li_organic").attr("data-value"), 
				recinte:  $("#li_recinte").attr("data-value")
		};
    	
    	
    	array_storage = JSON.parse( localStorage.getItem("empleats"));
    	if(array_storage == null){
    		//inicialitzem localStorage a array buit.
    		window.localStorage.setItem("empleats", JSON.stringify(array_buit));
    		array_storage = array_buit;
    	}
    	
    	//afegir el nou empleat a la resta d'empleats
    	array_storage.push(nova_entrada); 
   	
        //Sobreescric empleats per amb el nou empleat afegit
        window.localStorage.setItem("empleats", JSON.stringify(array_storage));
          
        pintarLlistaFavorits(array_storage);
    }
    
    /*
     * function eliminarContacteDeFavorits
     * 
     * Eliminar un contacte de favorits al storage.
     * @param id string codi de l'usuari a eliminar del storage
     */
    function eliminarContacteDeFavorits(id) {
    	
    	array_nou=[]; //array buit inicalment
    	array = JSON.parse( localStorage.getItem("empleats"));
    	
    	 l = array.length;
 	    //creem la llista
    	 for (var i = 0; i < l; i++) {
             if (array[i].contacte_id != id) {
            	 array_nou.push(array[i]); //afegim els contactes que no son el que volem eliminar
             }
         }
        
       	//Sobreescric empleats per sense l'empleat afegit
         window.localStorage.setItem("empleats", JSON.stringify(array_nou));
       
        pintarLlistaFavorits(array_nou);
    }
    
    
    /*
     * function pintarLlistaFavorits
     * 
     * pinta una llista amb els empleat favorits trets del storage
     * @param empleats string codi de l'usuari
     */
    function  pintarLlistaFavorits(empleats){
    	//vuidem la llista inicial
	    $('#llista-usuaris-favorits').empty();
	    
	    //Mirem si la llista est buida
    	if(empleats!=null){
		    l = empleats.length;
		    if(l==0){
		    	 $('#llista-usuaris-favorits').append('<li >No tens favorits en aquest moment</li>').trigger('create');;
		    }else{
			    //creem la llista
			    for (var i = 0; i < l; i++) {
			              var e = empleats[i];
			          	  if(((e.telefon_contacte).length)< 9 ){
			          		  telefon = '<a href="#purchase3" data-rel="popup" data-position-to="window" data-transition="pop" class="ui-btn ui-btn-icon-notext ui-icon-phone ui-btn-a">Trucar</a>';
			              }else{
			            	  telefon = '<a href="tel:' + e.telefon_contacte +'" class="ui-btn ui-btn-icon-notext ui-icon-phone ui-btn-a">Trucar</a>';
			              }
			              $('#llista-usuaris-favorits').append('<li class="ui-li-has-alt ui-li-has-thumb" data-value="'+e.contacte_id+'"><a href="#detall_contacte"   class="ui-btn"><img src="img/persona.png"><h2>' + 
			            		  e["nom"] + ' ' + e.cognoms +
					              '</h2><p>' + e.organic_desc + '<br>Tel. '+ e.telefon_contacte +
					              '</p></a>' + telefon + '</li>');
			    }
		    }
        }else{
        	 $('#llista-usuaris-favorits').append('<li >No tens favorits en aquest moment</li>').trigger('create');;
        }
    }
     
  	//Funci que afegeix un contacte a l'agenda de contactes del mbil.
    function afegirContacteAlMobil() {
    	
	    // Creaci d'un nou objete de contactes
	    var contact = navigator.contacts.create();
	    contact.displayName = $("#li_nom").attr("data-name") +' '+ $("#li_nom").attr("data-value");
	    contact.nickname =   $("#li_nom").attr("data-name") +' '+ $("#li_nom").attr("data-value");           // specify both to support all devices
	
	    var name = new ContactName();
	    name.givenName = $("#li_nom").attr("data-name");
	    name.familyName =  $("#li_nom").attr("data-value");
	    contact.name = name;
	    
	    var organizations = [];
	    organizations[0] = new ContactOrganization(false, 'work',  
	    		$("#li_recinte").attr("data-value"),
	    		$("#li_organic").attr("data-value"),'Empresa XX');
	    contact.organizations = organizations;
	    
	    var phoneNumbers = [];
	    phoneNumbers[0] = new ContactField('work', $("#li_tel").attr("data-value"), true);
	    contact.phoneNumbers = phoneNumbers;
	    
	    var emails = [];
	    emails[0] = new ContactField('work',  $("#li_email").attr("data-value"), false);
	    contact.emails = emails;
	
	    // Salvem en el dispositiu
	    contact.save(onSuccess,onError);
	    
    };
    
    function onSuccess() {
       // alert("Dades afegides als contactes particulars del mbil");
        $( "#dadesafegides2" ).popup( "open" );
    };

    function onError(contactError) {
        alert("Error = " + contactError.code);
    };

}());

